// AddWeaponDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "AddWeaponDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddWeaponDlg dialog


CAddWeaponDlg::CAddWeaponDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddWeaponDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddWeaponDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

    m_pInvestigator = NULL;
    m_pSkillToAdd = NULL;
    m_era = ERA_1920;
}


void CAddWeaponDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddWeaponDlg)
	DDX_Control(pDX, IDC_WEAPONSLIST, m_wndWeaponsList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddWeaponDlg, CDialog)
	//{{AFX_MSG_MAP(CAddWeaponDlg)
	ON_LBN_DBLCLK(IDC_WEAPONSLIST, OnDblclkWeaponslist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddWeaponDlg message handlers

void CAddWeaponDlg::OnDblclkWeaponslist() 
{
	OnOK();
}

BOOL CAddWeaponDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
    
    CSkillList::SkillList* pSkills = g_Firearms.GetList();
    BOOL fDoneMelee = FALSE;
	while( pSkills )
	{
        //only add this era's weapons
        if( pSkills->pSkill->IsEra( m_era ) )
		{
            //don't add core melee weapons like grapple and fist/punch
            if( pSkills->pSkill->m_strName[0] != '*' )
            {
			    if( ( m_pInvestigator->FindSkill( pSkills->pSkill->m_strName ) == NULL ) )
			    {
				    int iItem = m_wndWeaponsList.AddString( pSkills->pSkill->m_strName );
				    m_wndWeaponsList.SetItemData( iItem, (DWORD)pSkills->pSkill );
			    }
            }
		}

        //advance list
		pSkills = pSkills->next;

        //after adding firearms, add the melee weapons
        if( pSkills == NULL && fDoneMelee == FALSE )
        {
            pSkills = g_Melee.GetList();
            fDoneMelee = TRUE;
        }
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddWeaponDlg::OnOK() 
{
    int i = m_wndWeaponsList.GetCurSel();
    if( i != LB_ERR )
        m_pSkillToAdd = (CSkill*)m_wndWeaponsList.GetItemData( i );
    else
        m_pSkillToAdd = NULL;

	CDialog::OnOK();
}
