// CharacteristicsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "CharacteristicsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCharacteristicsDlg dialog


CCharacteristicsDlg::CCharacteristicsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCharacteristicsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCharacteristicsDlg)
	m_nAPP = 0;
	m_nCON = 0;
	m_nDEX = 0;
	m_nEDU = 0;
	m_strIdea = _T("");
	m_nINT = 0;
	m_strKnow = _T("");
	m_strLuck = _T("");
	m_strPersonalInterest = _T("");
	m_nPOW = 0;
	m_strSAN = _T("");
	m_nSIZ = 0;
	m_strSkillPoints = _T("");
	m_nSTR = 0;
	//}}AFX_DATA_INIT
}


void CCharacteristicsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCharacteristicsDlg)
	DDX_Text(pDX, IDC_APP, m_nAPP);
	DDV_MinMaxUInt(pDX, m_nAPP, 0, 100);
	DDX_Text(pDX, IDC_CON, m_nCON);
	DDV_MinMaxUInt(pDX, m_nCON, 0, 100);
	DDX_Text(pDX, IDC_DEX, m_nDEX);
	DDV_MinMaxUInt(pDX, m_nDEX, 0, 100);
	DDX_Text(pDX, IDC_EDU, m_nEDU);
	DDV_MinMaxUInt(pDX, m_nEDU, 0, 100);
	DDX_Text(pDX, IDC_IDEA, m_strIdea);
	DDX_Text(pDX, IDC_INT, m_nINT);
	DDV_MinMaxUInt(pDX, m_nINT, 0, 100);
	DDX_Text(pDX, IDC_KNOW, m_strKnow);
	DDX_Text(pDX, IDC_LUCK, m_strLuck);
	DDX_Text(pDX, IDC_PERSONALINTEREST, m_strPersonalInterest);
	DDX_Text(pDX, IDC_POW, m_nPOW);
	DDV_MinMaxUInt(pDX, m_nPOW, 0, 100);
	DDX_Text(pDX, IDC_SAN, m_strSAN);
	DDX_Text(pDX, IDC_SIZ, m_nSIZ);
	DDV_MinMaxUInt(pDX, m_nSIZ, 0, 100);
	DDX_Text(pDX, IDC_SKILLPOINTS, m_strSkillPoints);
	DDX_Text(pDX, IDC_STR, m_nSTR);
	DDV_MinMaxUInt(pDX, m_nSTR, 0, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCharacteristicsDlg, CDialog)
	//{{AFX_MSG_MAP(CCharacteristicsDlg)
	ON_EN_CHANGE(IDC_INT, OnChangeInt)
	ON_EN_CHANGE(IDC_EDU, OnChangeEdu)
	ON_EN_CHANGE(IDC_POW, OnChangePow)
	ON_BN_CLICKED(IDC_REROLL, OnReroll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCharacteristicsDlg message handlers

void CCharacteristicsDlg::OnChangeInt() 
{
    UpdateData();
	Recalculate();
    UpdateData(FALSE);
}

void CCharacteristicsDlg::OnChangeEdu() 
{
    UpdateData();
	Recalculate();
    UpdateData(FALSE);
}

void CCharacteristicsDlg::OnChangePow() 
{
    UpdateData();
	Recalculate();
    UpdateData(FALSE);
}

void CCharacteristicsDlg::OnReroll() 
{
	m_nAPP = GetValueInRange( D6_MIN, D6_MAX, 3 );
	m_nCON = GetValueInRange( D6_MIN, D6_MAX, 3 );
	m_nDEX = GetValueInRange( D6_MIN, D6_MAX, 3 );
	m_nPOW = GetValueInRange( D6_MIN, D6_MAX, 3 );
	m_nSTR = GetValueInRange( D6_MIN, D6_MAX, 3 );

	m_nSIZ = 6 + GetValueInRange( D6_MIN, D6_MAX, 2 );
	m_nINT = 6 + GetValueInRange( D6_MIN, D6_MAX, 2 );

	m_nEDU = 3 + GetValueInRange( D6_MIN, D6_MAX, 3 );
    
    Recalculate();
    UpdateData(FALSE);
}

BOOL CCharacteristicsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    if( m_nAPP == -1 )
        OnReroll();
    else
    {
	    Recalculate();
        UpdateData(FALSE);
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCharacteristicsDlg::Recalculate()
{
    m_strIdea.Format( "%d", m_nINT*5 );
    m_strPersonalInterest.Format( "%d", m_nINT*10 );

    m_strKnow.Format( "%d", m_nEDU*5 );
    m_strSkillPoints.Format( "%d", m_nEDU*20 );

    m_strLuck.Format( "%d", m_nPOW*5 );
    m_strSAN.Format( "%d", m_nPOW*5 );
}
