// EditSkillsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "EditSkillsDlg.h"
#include "NewSkillDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditSkillsDlg dialog


CEditSkillsDlg::CEditSkillsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditSkillsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditSkillsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

    m_pInvestigator = NULL;
}


void CEditSkillsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditSkillsDlg)
	DDX_Control(pDX, IDC_SKILLLIST, m_wndSkillList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditSkillsDlg, CDialog)
	//{{AFX_MSG_MAP(CEditSkillsDlg)
	ON_BN_CLICKED(IDC_ADDSKILL, OnAddskill)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditSkillsDlg message handlers

void CEditSkillsDlg::OnAddskill() 
{
    CNewSkillDlg NewSkill;

    if( NewSkill.DoModal() == IDOK )
    {
        CString strBase;
        strBase.Format( "%d", NewSkill.m_nBase );
        CSkill* pSkill = new CSkill( NewSkill.m_strName, strBase, TRUE, TRUE, TRUE );

        CInvestigator::InvestigatorSkillList* pNew = m_pInvestigator->AddSkill( pSkill, FALSE );
        if( pNew == NULL )
        {
            delete pSkill;
        }
        else
        {
            pNew->nCurrent = pNew->nMinimumValue = m_pInvestigator->GetSkillNumber( strBase );
            BuildSkillList();
        }
    }
}

void CEditSkillsDlg::OnDelete() 
{
    int i = m_wndSkillList.GetCurSel();
    if( i != LB_ERR )
    {
        CInvestigator::InvestigatorSkillList* pItem = (CInvestigator::InvestigatorSkillList*)m_wndSkillList.GetItemData(i);

        const char* pszName = LPCSTR(pItem->pSkill->m_strName);
        while( *pszName == '*' ) pszName++;

        CString strMessage = "\"";
        strMessage += pszName;
        strMessage += "\"\nAre you sure you want to delete this skill?";

        if( IDYES == AfxMessageBox( strMessage, MB_ICONQUESTION|MB_YESNO ) )
        {
            if( pItem->pSkill->GetType() == SPECIALISESKILL )
            {
                CSpecialiseSkill* pSpecial = (CSpecialiseSkill*)pItem->pSkill;
                for( int n = 0; n < pSpecial->m_nSkills; n++ )
                    m_pInvestigator->RemoveSkill( pSpecial->m_pSkillSpecialities[n] );
            }
            m_pInvestigator->RemoveSkill( pItem->pSkill );

            
            
            BuildSkillList();
        }
    }
}


BOOL CEditSkillsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    BuildSkillList();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditSkillsDlg::BuildSkillList()
{
    CInvestigator::InvestigatorSkillList* pList = m_pInvestigator->GetList();

    m_wndSkillList.ResetContent();

    while( pList )
    {
        if( pList->pSkill->GetType() != SPECIALISESKILLITEM && pList->pSkill->GetType() != ANYSKILL )
        {
            const char* pszName = LPCSTR(pList->pSkill->m_strName);
            while( *pszName == '*' ) pszName++;

            int i = m_wndSkillList.AddString( pszName );
            m_wndSkillList.SetItemData( i, (DWORD)pList );
        }

        pList = pList->next;        
    }
}
