// ListBoxChildEdit.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "ListBoxChildEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListBoxChildEdit

CListBoxChildEdit::CListBoxChildEdit()
{
	m_wndListBox = NULL;
	m_fEditing = FALSE;
	m_pSkill = NULL;

	m_nOldValue = 0;
	m_nChange = 0;

	m_pInvestigator = NULL;

	m_lpnSkillPoints = NULL;
    m_hWndSpin = NULL;
}

CListBoxChildEdit::~CListBoxChildEdit()
{
    m_wndFrame.DestroyWindow();
    if( m_hWndSpin ) ::DestroyWindow( m_hWndSpin );
}


BEGIN_MESSAGE_MAP(CListBoxChildEdit, CEdit)
	//{{AFX_MSG_MAP(CListBoxChildEdit)
	ON_WM_KEYDOWN()
	ON_WM_GETDLGCODE()
	ON_WM_KILLFOCUS()
	ON_WM_CHAR()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListBoxChildEdit message handlers



void CListBoxChildEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch( nChar )
	{
		case VK_UP:
		{	
			int n = m_wndListBox->GetCurSel();
			if( n > 0 ) 
			{
				m_wndListBox->SetCurSel( --n );
				ChangeEditing();
			}
			else MessageBeep(0xFFFFFFFF);
			break;
		}

		case VK_DOWN:
		{	
			int n = m_wndListBox->GetCurSel();
			int test = m_wndListBox->GetCount();
			if( n < (m_wndListBox->GetCount()-1) ) 
			{
				m_wndListBox->SetCurSel( ++n );
				ChangeEditing();
			}
			else
					MessageBeep(0xFFFFFFFF);
			break;
		}

		case VK_RETURN:
		case VK_ESCAPE:
            //don't call default handler
			break;

		default:
			CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
	}
}
void CListBoxChildEdit::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch( nChar )
	{
		case VK_RETURN:
        {
			int n = m_wndListBox->GetCurSel();
			int test = m_wndListBox->GetCount();
			if( n < (m_wndListBox->GetCount()-1) ) 
			{
				m_wndListBox->SetCurSel( ++n );
				ChangeEditing();
			}
			else
			    EndEditing();
			break;
        }

		case VK_ESCAPE:
			EndEditing( FALSE );
			break;

		default:
			CEdit::OnKeyUp(nChar, nRepCnt, nFlags);
	}
}


void CListBoxChildEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch( nChar )
	{
		case VK_RETURN:
			break;

		case VK_ESCAPE:
			break;

        default:
	        CEdit::OnChar(nChar, nRepCnt, nFlags);
    }
}

UINT CListBoxChildEdit::OnGetDlgCode() 
{
	if( IsWindowVisible() )
		return DLGC_WANTARROWS|DLGC_WANTALLKEYS;
	else
		return CEdit::OnGetDlgCode();
}

void CListBoxChildEdit::BeginEditing( CListBox* wndListBox, CInvestigator* pInvestigator, int* lpnSkillPoints )
{
	m_fEditing = TRUE;
	m_wndListBox = wndListBox;

	int iItem = wndListBox->GetCurSel();
    m_pSkill = (CInvestigator::InvestigatorSkillList*)m_wndListBox->GetItemData( iItem );

	if( m_pSkill->pSkill->GetType() == ANYSKILL || ( m_pSkill->pSkill->GetType() == SPECIALISESKILLITEM && m_pSkill->pSkill->m_strName.Compare("") == 0 ) )
	{
		EndEditing( FALSE );
		return;
	}

	m_pInvestigator = pInvestigator;
	m_lpnSkillPoints = lpnSkillPoints;


	CRect rc;
	wndListBox->GetItemRect( iItem, &rc );

	CRect rcListBox;
	wndListBox->GetClientRect( &rcListBox );

	rc.top += 2;
	rc.left = rc.right - 40;

    m_wndFrame.DestroyWindow();
    rc.right = rc.left + 38;
    rc.bottom = rc.top + 16;
    m_wndFrame.Create( "", WS_CHILD|WS_VISIBLE, rc, wndListBox );
	
    SetParent( &m_wndFrame );

	CString strCurrent;
	strCurrent.Format( "%d", m_pSkill->nCurrent );
	m_nOldValue = m_pSkill->nCurrent;
	m_nChange = 0;
	
	SetWindowText( strCurrent );

	SetSel( 0, -1 );
	SetWindowPos( &wndTop, 0, 0, rc.Width(), rc.Height(), SWP_SHOWWINDOW );
    if( m_hWndSpin ) ::DestroyWindow( m_hWndSpin );

    m_hWndSpin = ::CreateUpDownControl( WS_BORDER|WS_VISIBLE|WS_CHILD|UDS_ALIGNRIGHT|UDS_SETBUDDYINT|UDS_NOTHOUSANDS, 0, 0, 30, 30, m_wndFrame.m_hWnd, 0xFFFF, AfxGetInstanceHandle(), m_hWnd, 999, m_pSkill->nMinimumValue, m_pSkill->nCurrent );

	SetFocus();
}

void CListBoxChildEdit::EndEditing( BOOL fSaveChanges /*TRUE*/ )
{
	if( m_fEditing == FALSE ) return;
	
	if( fSaveChanges )
	{
		char szBuffer[32];
		GetWindowText( szBuffer, 32 );

		//clip it to a valid selection
		int nNewValue = atoi(szBuffer);

		BOOL fSomethingFishy = FALSE;

		//don't let it be set below the base value
		if( nNewValue < m_pSkill->nMinimumValue )
		{
			fSomethingFishy = TRUE;
			nNewValue = m_pSkill->nMinimumValue;
		}
		
		//make sure they've got enough skill points left
		if( *m_lpnSkillPoints - (nNewValue - m_nOldValue) < 0 )
		{
			nNewValue = m_nOldValue + *m_lpnSkillPoints;
			fSomethingFishy = TRUE;
		}

		//calculate the change
		m_nChange = nNewValue - m_nOldValue;

		//update the value
		*m_lpnSkillPoints -= m_nChange;

		//anything wrong?
		if( fSomethingFishy ) MessageBeep(0xFFFFFFFF);

		//update display
		CString str;
		str.Format( "%d", *m_lpnSkillPoints );
		m_wndListBox->GetParent()->SetDlgItemText( IDC_POINTS, str );

		//update value in the skill
		m_pSkill->nCurrent = nNewValue;
	}
	
	m_fEditing = FALSE;
    if( m_hWndSpin ) ::DestroyWindow( m_hWndSpin );
    m_hWndSpin = NULL;

	if( ::IsWindow(m_hWnd) && m_wndListBox) 
	{
		ShowWindow( SW_HIDE );
		SetParent( m_wndListBox->GetParent() );
		m_wndListBox = NULL;
	}

    m_wndFrame.DestroyWindow();

}

void CListBoxChildEdit::OnKillFocus( CWnd* pNewWnd )
{
	CEdit::OnKillFocus(pNewWnd);
	EndEditing();	
}

void CListBoxChildEdit::ChangeEditing()
{
	CListBox* wndListBox = m_wndListBox;
	EndEditing();
	BeginEditing( wndListBox, m_pInvestigator, m_lpnSkillPoints );
}
