// NewDocument.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "NewDocument.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewDocument dialog

//store the most recently visited page globally and use it next time the
//dialog is called. It is simple, foul, quick and dirty hacks like this
//which give that little extra bit of "nice"
int g_iPage = 1; //(1 = investigator wizards page)


CNewDocument::CNewDocument(CWnd* pParent /*=NULL*/)
	: CDialog(CNewDocument::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewDocument)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

    //build the image list
    m_ImageList.Create( 32, 32, ILC_COLOR4|ILC_MASK, 0, 0 );

    m_ImageList.Add( LoadIcon( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_SHEETTYPE) ) );
    m_ImageList.Add( LoadIcon( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_WIZARD) ) );
    m_ImageList.Add( LoadIcon( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_PARTIALWIZARD) ) );
    m_ImageList.Add( LoadIcon( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_HANDOUTTYPE) ) );

    m_strHandoutName = "";
}


void CNewDocument::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewDocument)
	DDX_Control(pDX, IDC_NEWTYPE_TAB, m_wndTabCtrl);
	DDX_Control(pDX, IDC_AVAILABLETYPES, m_wndAvailableTypes);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewDocument, CDialog)
	//{{AFX_MSG_MAP(CNewDocument)
	ON_NOTIFY(NM_DBLCLK, IDC_AVAILABLETYPES, OnDblclkAvailabletypes)
	ON_NOTIFY(TCN_SELCHANGE, IDC_NEWTYPE_TAB, OnSelchangeNewtypeTab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewDocument message handlers

void CNewDocument::OnDblclkAvailabletypes(NMHDR* pNMHDR, LRESULT* pResult) 
{
    OnOK();
	
	*pResult = 0;
}

BOOL CNewDocument::OnInitDialog() 
{
	CDialog::OnInitDialog();

    m_NewDocument = NOTHING;

    //initialise the image list
    m_wndAvailableTypes.SetImageList( &m_ImageList, LVSIL_NORMAL );

    //add the tabs
    m_wndTabCtrl.DeleteAllItems();
    TC_ITEM tci;
    tci.mask = TCIF_TEXT;
    tci.pszText = "Investigator Sheets"; m_wndTabCtrl.InsertItem( 0, &tci );
    tci.pszText = "Wizards";             m_wndTabCtrl.InsertItem( 1, &tci );
    tci.pszText = "Handouts";            m_wndTabCtrl.InsertItem( 2, &tci );

    //show the wizards page
    m_wndTabCtrl.SetCurSel( g_iPage );
    InitialisePage( g_iPage );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNewDocument::OnSelchangeNewtypeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
    g_iPage = m_wndTabCtrl.GetCurSel();
    InitialisePage( g_iPage );
	
	*pResult = 0;
}

void CNewDocument::InitialisePage(int iPage)
{
    m_wndAvailableTypes.DeleteAllItems();
    switch( iPage )
    {
        case 0: //blank sheets
        {
            LV_ITEM lvi;
            lvi.mask = LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM|LVIF_STATE;
            lvi.stateMask = LVIS_FOCUSED;
            lvi.iSubItem = 0;
            lvi.iItem = 0;
            lvi.iImage = 0; //0 = normal document icon
            lvi.state = LVIS_FOCUSED;
            lvi.lParam = (LPARAM)BLANK_1890; lvi.pszText = "Blank 1890s"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.state = 0;
            lvi.lParam = (LPARAM)BLANK_1920; lvi.pszText = "Blank 1920s"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.lParam = (LPARAM)BLANK_1990; lvi.pszText = "Blank 1990s"; m_wndAvailableTypes.InsertItem( &lvi );
            break;
        }

        case 1: //wizards
        {
            LV_ITEM lvi;
            lvi.mask = LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM|LVIF_STATE;
            lvi.stateMask = LVIS_FOCUSED;
            lvi.iSubItem = 0;
            lvi.iItem = 0;
            lvi.iImage = 1; //1 = wizard icon
            lvi.state = LVIS_FOCUSED;
            lvi.lParam = (LPARAM)WIZARD_1890; lvi.pszText = "1890s Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.state = 0;
            lvi.lParam = (LPARAM)WIZARD_1920; lvi.pszText = "1920s Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.lParam = (LPARAM)WIZARD_1990; lvi.pszText = "1990s Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.iImage = 2; //2 = partial wizard icon
            lvi.lParam = (LPARAM)SMALLWIZ_1890; lvi.pszText = "1890s Core Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.lParam = (LPARAM)SMALLWIZ_1920; lvi.pszText = "1920s Core Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            lvi.lParam = (LPARAM)SMALLWIZ_1990; lvi.pszText = "1990s Core Wizard"; m_wndAvailableTypes.InsertItem( &lvi );
            break;
        }

        case 2: //handouts
        {
            LV_ITEM lvi;
            lvi.mask = LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM|LVIF_STATE;
            lvi.stateMask = LVIS_FOCUSED;
            lvi.iSubItem = 0;
            lvi.iItem = 0;
            lvi.iImage = 3; //3 = handout icon
            lvi.state = LVIS_FOCUSED;
            lvi.lParam = (LPARAM)"Telegram"; lvi.pszText = "Telegram"; m_wndAvailableTypes.InsertItem( &lvi );
            break;
        }

        default:
            ASSERT(FALSE);
            break;
    }
}

void CNewDocument::OnOK() 
{
    LV_ITEM lvi;
    lvi.mask = LVIF_PARAM|LVIF_STATE;
    lvi.iSubItem = 0;
    lvi.stateMask = (LVIS_SELECTED|LVIS_FOCUSED);

    int max = m_wndAvailableTypes.GetItemCount();
    for( int i = 0; i < max; i++ )
    {
        lvi.iItem = i;
        m_wndAvailableTypes.GetItem( &lvi );
        if( lvi.state & (LVIS_SELECTED|LVIS_FOCUSED) )
        {
            if( m_wndTabCtrl.GetCurSel() == 2 )
            {
                m_NewDocument = HANDOUT;
                m_strHandoutName = (char*)lvi.lParam;
            }
            else
            {
                m_NewDocument = (NewDocType)lvi.lParam;
            }
            CDialog::OnOK();
            return;
        }
    }
    m_NewDocument = NOTHING;
    AfxMessageBox( "Unexpected error selecting document" );
	CDialog::OnOK();
}
