// Options_Pages.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Cthulhu.h"
#include "Options_Pages.h"
#include "Skill.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(COptions_Page1, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page2, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page3, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page4, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page5, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page6, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page7, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page8, CPropertyPage)
IMPLEMENT_DYNCREATE(COptions_Page9, CPropertyPage)


/////////////////////////////////////////////////////////////////////////////
// COptions_Page1 property page

int CALLBACK BuildFontListCallback( ENUMLOGFONT FAR *lpelf, NEWTEXTMETRIC FAR *lpntm, int FontType, COptions_Page1* pOptionsDlg )
{
    if( FontType & TRUETYPE_FONTTYPE )
    {
        pOptionsDlg->m_wndTitleFont.AddString( lpelf->elfLogFont.lfFaceName );
        pOptionsDlg->m_wndUserTextFont.AddString( lpelf->elfLogFont.lfFaceName );
        pOptionsDlg->m_wndDeltaGreen.AddString( lpelf->elfLogFont.lfFaceName );
    }

    return TRUE;
}

void AddComboFiles(CComboBox & wndCombo, CString strFiles)
{
	CString strPattern = GetDefaultDirectory() + strFiles;
	WIN32_FIND_DATA findData;
	HANDLE hFind = FindFirstFile( strPattern, &findData );
	while( hFind && hFind != INVALID_HANDLE_VALUE )
	{
		//add it to the list
        wndCombo.AddString( findData.cFileName );

		//find the next file
		if( FindNextFile( hFind, &findData ) == FALSE )
		{
			FindClose( hFind );
			hFind = NULL;
		}
	}
    
}


COptions_Page1::COptions_Page1() : CPropertyPage(COptions_Page1::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page1)
	m_strTitleFace = _T("Times New Roman");
	m_strUserTextFace = _T("Comic Sans MS");
	m_strDeltaGreen = _T("Arial");
	//}}AFX_DATA_INIT

    m_crUserTextColour = RGB(0,0,128);
}

COptions_Page1::~COptions_Page1()
{
}

void COptions_Page1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page1)
	DDX_Control(pDX, IDC_DELTAGREEN, m_wndDeltaGreen);
	DDX_Control(pDX, IDC_TITLEFONT, m_wndTitleFont);
	DDX_Control(pDX, IDC_USERTEXTFONT, m_wndUserTextFont);
	DDX_CBString(pDX, IDC_TITLEFONT, m_strTitleFace);
	DDX_CBString(pDX, IDC_USERTEXTFONT, m_strUserTextFace);
	DDX_CBString(pDX, IDC_DELTAGREEN, m_strDeltaGreen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page1, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page1)
	ON_BN_CLICKED(IDC_SETCOLOUR, OnSetUserTextColour)
	ON_WM_DRAWITEM()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL COptions_Page1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    //get a list of all fonts and stick 'em in the combo boxes
    AfxGetMainWnd()->BeginWaitCursor();
    CDC* pDC = GetDC();
    EnumFontFamilies( pDC->m_hDC, (LPCTSTR)NULL, (FONTENUMPROC)BuildFontListCallback, (LPARAM)this );
    ReleaseDC(pDC);
    AfxGetMainWnd()->EndWaitCursor();

    //load settings
	m_crUserTextColour = AfxGetApp()->GetProfileInt( "Sheet", "UserTextColour", RGB(0,0,128) );
	m_strUserTextFace = AfxGetApp()->GetProfileString( "Sheet", "UserTextFace", "Comic Sans MS" );
    m_strTitleFace = AfxGetApp()->GetProfileString( "Sheet", "TitleFace", "Times New Roman" );
    m_strDeltaGreen = AfxGetApp()->GetProfileString( "Sheet", "DeltaGreen", "Arial" );

    UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void COptions_Page1::OnSetUserTextColour() 
{
    static COLORREF crCustom[16] = { 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF, 0xFFFFFF };

    //display a colour selection dialog
    CColorDialog ColourPick( m_crUserTextColour, CC_ANYCOLOR|CC_FULLOPEN|CC_RGBINIT, this );
    ColourPick.m_cc.lpCustColors = crCustom;

    if( ColourPick.DoModal() == IDOK )
    {
        m_crUserTextColour = ColourPick.m_cc.rgbResult;
    }
}

void COptions_Page1::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
    if( nIDCtl == IDC_SETCOLOUR )
    {
        DrawEdge( lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, EDGE_SUNKEN, BF_RECT|BF_SOFT );
 
        CRect rcFill = lpDrawItemStruct->rcItem;
        rcFill.top += 1; rcFill.left += 1; rcFill.bottom -= 1; rcFill.right -= 1;
        CBrush br( m_crUserTextColour );
        FillRect( lpDrawItemStruct->hDC, &rcFill, HBRUSH(br) );

        if( lpDrawItemStruct->itemState & ODS_FOCUS )
        {
            rcFill = lpDrawItemStruct->rcItem;
            rcFill.top += 3; rcFill.left += 3; rcFill.bottom -= 3; rcFill.right -= 3;
            DrawFocusRect( lpDrawItemStruct->hDC, &rcFill );
        }
    }
    else
    	CPropertyPage::OnDrawItem(nIDCtl, lpDrawItemStruct);
}


void COptions_Page1::OnOK() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "Sheet", "UserTextColour", m_crUserTextColour );
    AfxGetApp()->WriteProfileString( "Sheet", "UserTextFace", m_strUserTextFace );
    AfxGetApp()->WriteProfileString( "Sheet", "TitleFace", m_strTitleFace );
    AfxGetApp()->WriteProfileString( "Sheet", "DeltaGreen", m_strDeltaGreen );
	
	CPropertyPage::OnOK();
}


/////////////////////////////////////////////////////////////////////////////
// COptions_Page2 property page

COptions_Page2::COptions_Page2() : CPropertyPage(COptions_Page2::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page2)
	m_iRotateType = -1;
	//}}AFX_DATA_INIT
}

COptions_Page2::~COptions_Page2()
{
}

void COptions_Page2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page2)
	DDX_Radio(pDX, IDC_ROTATE_NORMAL, m_iRotateType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page2, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL COptions_Page2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

    //load settings
    m_iRotateType = AfxGetApp()->GetProfileInt( "Sheet", "RotateType", 0 );

    UpdateData(FALSE);
	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void COptions_Page2::OnOK() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "Sheet", "RotateType", m_iRotateType );
	
	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// COptions_Page3 property page

COptions_Page3::COptions_Page3() : CPropertyPage(COptions_Page3::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page3)
	m_nTopMargin = 0;
	//}}AFX_DATA_INIT
}

COptions_Page3::~COptions_Page3()
{
}

void COptions_Page3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page3)
	DDX_Control(pDX, IDC_TOPMARGINSPIN, m_wndTopMarginSpin);
	DDX_Text(pDX, IDC_TOPMARGIN, m_nTopMargin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page3, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL COptions_Page3::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    //set the limits for the spin control
    m_wndTopMarginSpin.SetRange( 0, 1000 );

    //load settings
    m_nTopMargin = AfxGetApp()->GetProfileInt( "Sheet", "TopMargin", 180 );

    UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptions_Page3::OnOK() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "Sheet", "TopMargin", m_nTopMargin );
	
	CPropertyPage::OnOK();
}



/////////////////////////////////////////////////////////////////////////////
// COptions_Page4 property page

COptions_Page4::COptions_Page4() : CPropertyPage(COptions_Page4::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page4)
	m_fFlatToolbar = FALSE;
	m_strMainDataFile = _T("coc5.rul");
	m_strRulefileCredits = _T("");
	//}}AFX_DATA_INIT
}

COptions_Page4::~COptions_Page4()
{
}

void COptions_Page4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page4)
	DDX_Control(pDX, IDC_MAINDATAFILE, m_wndMainDataFile);
	DDX_Check(pDX, IDC_FLATTOOLBAR, m_fFlatToolbar);
	DDX_CBString(pDX, IDC_MAINDATAFILE, m_strMainDataFile);
	DDX_Text(pDX, IDC_CREDITS, m_strRulefileCredits);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page4, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page4)
	ON_CBN_SELCHANGE(IDC_MAINDATAFILE, OnSelchangeMaindatafile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL COptions_Page4::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    //add all of the current files to the combo box
    AddComboFiles( m_wndMainDataFile, "*.rul" );

    //load all settings
	m_fFlatToolbar = AfxGetApp()->GetProfileInt( "Display", "FlatToolbar", TRUE );
    m_strMainDataFile = AfxGetApp()->GetProfileString( "Data", "Rules", "coc5.rul" );
    if( m_strMainDataFile.GetLength() == 0 ) m_strMainDataFile = "coc5.rul";
    UpdateData(FALSE);

    //display current credits in the text box
    OnSelchangeMaindatafile();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void COptions_Page4::OnOK() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "Display", "FlatToolbar", m_fFlatToolbar );
    
    if( m_strMainDataFile.GetLength() == 0 ) m_strMainDataFile = "coc5.rul";
    AfxGetApp()->WriteProfileString( "Data", "Rules", m_strMainDataFile );
	
	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// COptions_Page5 property page

COptions_Page5::COptions_Page5() : CPropertyPage(COptions_Page5::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page5)
	m_iSaveType = 1;
	//}}AFX_DATA_INIT
}

COptions_Page5::~COptions_Page5()
{
}

void COptions_Page5::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page5)
	DDX_CBIndex(pDX, IDC_SAVEVERSIONCOMBO, m_iSaveType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page5, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL COptions_Page5::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_iSaveType = AfxGetApp()->GetProfileInt( "Save", "SaveVersion", 1 );
    UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptions_Page5::OnOK() 
{
    UpdateData();
    AfxGetApp()->WriteProfileInt( "Save", "SaveVersion", m_iSaveType );
	
	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// COptions_Page6 property page

COptions_Page6::COptions_Page6() : CPropertyPage(COptions_Page6::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page6)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COptions_Page6::~COptions_Page6()
{
}

void COptions_Page6::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page6)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page6, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page6)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COptions_Page7 property page

COptions_Page7::COptions_Page7() : CPropertyPage(COptions_Page7::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page7)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COptions_Page7::~COptions_Page7()
{
}

void COptions_Page7::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page7)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page7, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page7)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COptions_Page8 property page

COptions_Page8::COptions_Page8() : CPropertyPage(COptions_Page8::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page8)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COptions_Page8::~COptions_Page8()
{
}

void COptions_Page8::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page8)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page8, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page8)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COptions_Page9 property page

COptions_Page9::COptions_Page9() : CPropertyPage(COptions_Page9::IDD)
{
	//{{AFX_DATA_INIT(COptions_Page9)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COptions_Page9::~COptions_Page9()
{
}

void COptions_Page9::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions_Page9)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions_Page9, CPropertyPage)
	//{{AFX_MSG_MAP(COptions_Page9)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void COptions_Page4::OnSelchangeMaindatafile() 
{
    UpdateData();

    m_strRulefileCredits = "";
    if( m_strMainDataFile.GetLength() > 0 )
    {
        //display the rule file credit, if any
        CString* pstrCredit = GetOptions( "CREDIT", m_strMainDataFile );
        if( pstrCredit )
        {
            int i = 0;
            while( pstrCredit[i].GetLength() > 0 )
            {
                m_strRulefileCredits += pstrCredit[i];
                m_strRulefileCredits += "\r\n";
                i++;
            }

            delete[] pstrCredit;
        }
        else
            m_strRulefileCredits = "No credits for the current rule file";

        UpdateData(FALSE);
    }
	
}
