// TelegramDoc.cpp : implementation of the CTelegramDoc class
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "GetMultilineText.h"
#include "TelegramDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTelegramDoc

IMPLEMENT_DYNCREATE(CTelegramDoc, CDocument)

BEGIN_MESSAGE_MAP(CTelegramDoc, CDocument)
	ON_COMMAND(ID_FILE_SEND_MAIL, OnFileSendMail)
	ON_UPDATE_COMMAND_UI(ID_FILE_SEND_MAIL, OnUpdateFileSendMail)
	//{{AFX_MSG_MAP(CTelegramDoc)
	ON_COMMAND(ID_EDIT_TELEGRAMFONT, OnEditTelegramFont)
	ON_COMMAND(ID_EDIT_TELEGRAMTEXT, OnEditTelegramText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTelegramDoc construction/destruction

CTelegramDoc::CTelegramDoc()
{
    //load telegram picture
    CString strTelegramPic = GetDefaultDirectory();
    strTelegramPic += "telegram.emf";
    m_hEmf = GetEnhMetaFile( strTelegramPic );

    m_strHandoutName = "";
}

CTelegramDoc::~CTelegramDoc()
{
    if( m_hEmf ) DeleteEnhMetaFile( m_hEmf ); 
}

BOOL CTelegramDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

    for( int i = 0; i < 20; i++ )
    {
        m_Text[i].strText = "";
        m_Text[i].crText = 0x000000;
        m_Text[i].LogFont.lfHeight = -48;
        m_Text[i].LogFont.lfWidth = 0;
        m_Text[i].LogFont.lfEscapement = 0;
        m_Text[i].LogFont.lfOrientation = 0;
        m_Text[i].LogFont.lfWeight = FW_NORMAL;
        m_Text[i].LogFont.lfItalic = 0;
        m_Text[i].LogFont.lfUnderline = 0;
        m_Text[i].LogFont.lfStrikeOut = 0; 
        m_Text[i].LogFont.lfCharSet = 0;
        m_Text[i].LogFont.lfOutPrecision = 0;
        m_Text[i].LogFont.lfClipPrecision = 0; 
        m_Text[i].LogFont.lfQuality = 0;
        m_Text[i].LogFont.lfPitchAndFamily = 0;
        strcpy( m_Text[i].LogFont.lfFaceName, "Times New Roman" );
    }

    //quick hack for telegram type
    strcpy( m_Text[0].LogFont.lfFaceName, "Courier New" );

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTelegramDoc serialization

void CTelegramDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
        ar.WriteString( HANDOUT_FILE_HEADER10 ); ar << '\n';
        ar << m_strHandoutName;
        for( int i = 0; i < 20; i++ )
        {
            ar << m_Text[i].strText;
            ar << m_Text[i].crText;
            ar << m_Text[i].LogFont.lfHeight;
            ar << m_Text[i].LogFont.lfWidth;
            ar << m_Text[i].LogFont.lfEscapement;
            ar << m_Text[i].LogFont.lfOrientation;
            ar << m_Text[i].LogFont.lfWeight;
            ar << m_Text[i].LogFont.lfItalic;
            ar << m_Text[i].LogFont.lfUnderline;
            ar << m_Text[i].LogFont.lfStrikeOut; 
            ar << m_Text[i].LogFont.lfCharSet;
            ar << m_Text[i].LogFont.lfOutPrecision;
            ar << m_Text[i].LogFont.lfClipPrecision; 
            ar << m_Text[i].LogFont.lfQuality;
            ar << m_Text[i].LogFont.lfPitchAndFamily;
            ar.WriteString( m_Text[i].LogFont.lfFaceName );  ar << '\n';
        }
	}
	else
	{
        int nVersionMajor = 0, nVersionMinor = 0;

        //header
        CString strHeader;
        ar.ReadString( strHeader );

        if( strHeader.Compare( HANDOUT_FILE_HEADER10 ) == 0 )
        {
            nVersionMajor = 1;
            nVersionMinor = 0;
        }
        else
        {
            AfxThrowArchiveException( CArchiveException::badIndex, "" );
            return;
        }

        //basic stats
        if( nVersionMajor >= 1 && nVersionMinor >= 0 )
        {
            ar >> m_strHandoutName;
            for( int i = 0; i < 20; i++ )
            {
                ar >> m_Text[i].strText;
                ar >> m_Text[i].crText;
                ar >> m_Text[i].LogFont.lfHeight;
                ar >> m_Text[i].LogFont.lfWidth;
                ar >> m_Text[i].LogFont.lfEscapement;
                ar >> m_Text[i].LogFont.lfOrientation;
                ar >> m_Text[i].LogFont.lfWeight;
                ar >> m_Text[i].LogFont.lfItalic;
                ar >> m_Text[i].LogFont.lfUnderline;
                ar >> m_Text[i].LogFont.lfStrikeOut; 
                ar >> m_Text[i].LogFont.lfCharSet;
                ar >> m_Text[i].LogFont.lfOutPrecision;
                ar >> m_Text[i].LogFont.lfClipPrecision; 
                ar >> m_Text[i].LogFont.lfQuality;
                ar >> m_Text[i].LogFont.lfPitchAndFamily;

                CString strFaceName;
                ar.ReadString( strFaceName );
                ZeroMemory( &m_Text[i].LogFont.lfFaceName, LF_FACESIZE );
                strncpy( m_Text[i].LogFont.lfFaceName, strFaceName, LF_FACESIZE-1 );
            }
        }
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTelegramDoc diagnostics

#ifdef _DEBUG
void CTelegramDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTelegramDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTelegramDoc commands

void CTelegramDoc::OnEditTelegramFont() 
{
    //get a pointer to the first view
    POSITION p = GetFirstViewPosition();
    CView* pView = GetNextView(p);

    if( pView )
    {
        //display the dialog for the view
        CDC* pDC = pView->GetDC();
        CFontDialog PickFont( &m_Text[0].LogFont, CF_EFFECTS|CF_BOTH );
        PickFont.m_cf.rgbColors = m_Text[0].crText;
        PickFont.m_cf.hDC = pDC->m_hDC;

        if( PickFont.DoModal() == IDOK )
        {
            m_Text[0].crText = PickFont.m_cf.rgbColors;
            UpdateAllViews( NULL );
        }

        pView->ReleaseDC( pDC );
    }
    else
    {
        AfxMessageBox( "Internal Error - cannot find a view to create the fonts for!", MB_ICONERROR );
    }
}

void CTelegramDoc::OnEditTelegramText() 
{
    CGetMultilineText GetMultilineText;
    GetMultilineText.m_strText = m_Text[0].strText;
    if( GetMultilineText.DoModal() == IDOK )
    {
        m_Text[0].strText = GetMultilineText.m_strText;
        UpdateAllViews( NULL );
    }
}

void CTelegramDoc::EditTelegramText()
{
    OnEditTelegramText();
}
