// TelegramView.cpp : implementation of the CTelegramView class
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "TelegramDoc.h"
#include "TelegramView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTelegramView

IMPLEMENT_DYNCREATE(CTelegramView, CScrollView)

BEGIN_MESSAGE_MAP(CTelegramView, CScrollView)
	//{{AFX_MSG_MAP(CTelegramView)
	ON_WM_ERASEBKGND()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTelegramView construction/destruction

CTelegramView::CTelegramView()
{
    m_rcTelegram.SetRect( 0, 0, 1670, -1180 );
    SetScrollSizes( MM_LOMETRIC, CSize( m_rcTelegram.Width(), -m_rcTelegram.Height() ) );
}

CTelegramView::~CTelegramView()
{
}

BOOL CTelegramView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTelegramView drawing

void CTelegramView::OnDraw(CDC* pDC)
{
	CTelegramDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    //clear the background
    pDC->FillRect( &m_rcTelegram, CBrush::FromHandle((HBRUSH)::GetStockObject(WHITE_BRUSH)));


    //draw the telegram background
    if( pDoc->m_hEmf )
    {
        //draw the metafile
        PlayEnhMetaFile( pDC->m_hDC, pDoc->m_hEmf, &m_rcTelegram );
    }


    //set background mode
    pDC->SetBkMode( TRANSPARENT );


    //draw the disclaimer text
    CRect rcDisclaimer( 190, -1010, m_rcTelegram.right-190, -1120 );
    CString strDisclaimer = "WWT makes good-faith effort to receive, transmit, and/or deliver all communications, but can\nshare no responsibility for incomplete, inaccurate, stolen, misconstrued, missent, or missing\ncommunications, whether by negligence, mistake, conspiracy, error, war, or act of God.";

    CFont DisclaimerFont;
    DisclaimerFont.CreateFont( -30, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, "Times New Roman" );
    CFont* pOldFont = pDC->SelectObject( &DisclaimerFont );

    pDC->SetTextColor( 0xFFFFFF ); //white
    pDC->DrawText( strDisclaimer, &rcDisclaimer, DT_CENTER|DT_NOPREFIX|DT_NOCLIP );


    //draw actual text
    CRect rcText( 190, -350, m_rcTelegram.right-190, 900 );

    CFont TextFont;
    TextFont.CreateFontIndirect( &pDoc->m_Text[0].LogFont );
    pDC->SelectObject( &TextFont );

    pDC->SetTextColor( pDoc->m_Text[0].crText );
    pDC->DrawText( pDoc->m_Text[0].strText, &rcText, DT_LEFT|DT_NOPREFIX|DT_WORDBREAK|DT_NOCLIP );


    //put old font back
    pDC->SelectObject( pOldFont );

  
}

/////////////////////////////////////////////////////////////////////////////
// CTelegramView printing

BOOL CTelegramView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTelegramView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTelegramView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CTelegramView diagnostics

#ifdef _DEBUG
void CTelegramView::AssertValid() const
{
	CView::AssertValid();
}

void CTelegramView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTelegramDoc* CTelegramView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTelegramDoc)));
	return (CTelegramDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTelegramView message handlers

BOOL CTelegramView::OnEraseBkgnd(CDC* pDC) 
{
    CBrush br( GetSysColor( COLOR_APPWORKSPACE ));
    FillOutsideRect( pDC, &br );
    return TRUE;
}

BOOL CTelegramView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
    if( nHitTest == HTCLIENT )
    {
        SetCursor( AfxGetApp()->LoadCursor( IDC_HAND ) );	
        return TRUE;
    }
    else
        return CScrollView::OnSetCursor( pWnd, nHitTest, message );
}

void CTelegramView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CTelegramDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    pDoc->EditTelegramText();
	
	CScrollView::OnLButtonUp(nFlags, point);
}
